Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2276)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2277)
@@ -490,261 +496,264 @@
     USE kinds
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m                  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m_l                !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m                  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m_l                !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m                  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m_l                !<    
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu                   !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu_pres              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dd2zu                  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzu                    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzw                   !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzw                    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyp                    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  inflow_damping_factor  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_grid                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_x                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_y                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_surf                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_surf                !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_init                !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_surf              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_init                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_surf                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf                    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf_sc                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ref_state              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_init                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_surf                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  sa_init                !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  shf_surf               !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  timenudge              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_surf              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_vert              !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tmp_tnudge             !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ug                     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_init                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_nzb_p1_for_vfc       !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vg                     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_init                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_nzb_p1_for_vfc       !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  w_subs                 !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu                     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw                     !< 
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_u                   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_v                   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_w                   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_e              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_nr             !<     
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_pt             !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_q              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qr             !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_s              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_sa             !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_u              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_v              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_w              !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzu_mg                !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzw_mg                !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_e              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_nr             !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_pt             !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_q              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qr             !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_s              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_sa             !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_u              !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_v              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_w              !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f1_mg                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f2_mg                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f3_mg                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  mean_inflow_profiles  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ptnudge               !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_slope_ref          !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qnudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tnudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_lpt            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_q              !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_lpt            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_q              !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_a            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_o            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug_vert               !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  unudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vnudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg_vert               !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wnudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wsubs_vert            !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m                  !< Siggi 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m_l                !< Siggi 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m                  !< Siggi 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m_l                !< Siggi 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m                  !< Siggi 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m_l                !< Siggi    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu                   !< 1/dzu 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu_pres              !< modified ddzu for pressure solver 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dd2zu                  !< 1/(dzu(k)+dzu(k+1)) 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzu                    !< vertical grid size (u-grid) 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzw                   !< 1/dzw 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzw                    !< vertical grid size (w-grid) 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyp                    !< hydrostatic pressure 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  inflow_damping_factor  !< used for turbulent inflow (non-cyclic boundary conditions) 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_grid                 !< geometric mean of grid sizes dx, dy, dz 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_x                 !< damping factor for potential temperature in x-direction 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_y                 !< damping factor for potential temperature in y-direction 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_surf                 !< time-dependent surface pressure (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_surf                !< time-dependent surface temperature (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_init                !< initial profile of potential temperature 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_surf              !< time-dependent surface latent heat flux (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_init                 !< initial profile of specific humidity 
+                                                                   !< (or total water content with active cloud physics) 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_surf                 !< time-dependent surface specific humidity (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf                    !< rayleigh damping factor for velocity components 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf_sc                 !< rayleigh damping factor for scalar quantities 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ref_state              !< reference state of potential temperature 
+                                                                   !< (and density in case of ocean simulation)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_init                 !< initial profile of passive scalar concentration
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  sa_init                !< initial profile of salinity (ocean)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  shf_surf               !< time-dependent surface sensible heat flux (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  timenudge              !< times at which vertical profiles are defined in NUDGING_DATA (nudging)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_surf              !< times at which surface values/fluxes are defined in LSF_DATA (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_vert              !< times at which vertical profiles are defined in LSF_DATA (large scale forcing)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tmp_tnudge             !< current nudging time scale
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ug                     !< geostrophic wind component in x-direction
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_init                 !< initial profile of horizontal velocity component u
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vg                     !< geostrophic wind component in y-direction
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_init                 !< initial profile of horizontal velocity component v
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  w_subs                 !< subsidence/ascent velocity
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu                     !< vertical grid coordinate of u-grid (in m)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw                     !< vertical grid coordinate of w-grid (in m)
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_u                   !< phase speed of u-velocity component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_v                   !< phase speed of v-velocity component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_w                   !< phase speed of w-velocity component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_e              !< artificial numerical dissipation flux at south face of grid box - subgrid-scale TKE
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_nr             !< artificial numerical dissipation flux at south face of grid box - raindrop-number concentration    
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_pt             !< artificial numerical dissipation flux at south face of grid box - potential temperature 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_q              !< artificial numerical dissipation flux at south face of grid box - mixing ratio 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qr             !< artificial numerical dissipation flux at south face of grid box - rainwater 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_s              !< artificial numerical dissipation flux at south face of grid box - passive scalar
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_sa             !< artificial numerical dissipation flux at south face of grid box - salinity
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_u              !< artificial numerical dissipation flux at south face of grid box - u-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_v              !< artificial numerical dissipation flux at south face of grid box - v-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_w              !< artificial numerical dissipation flux at south face of grid box - w-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzu_mg                !< vertical grid size (u-grid) for multigrid pressure solver
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzw_mg                !< vertical grid size (w-grid) for multigrid pressure solver
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_e              !< 6th-order advective flux at south face of grid box - subgrid-scale TKE
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_nr             !< 6th-order advective flux at south face of grid box - raindrop-number concentration 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_pt             !< 6th-order advective flux at south face of grid box - potential temperature 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_q              !< 6th-order advective flux at south face of grid box - mixing ratio 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qr             !< 6th-order advective flux at south face of grid box - rainwater
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_s              !< 6th-order advective flux at south face of grid box - passive scalar
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_sa             !< 6th-order advective flux at south face of grid box - salinity
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_u              !< 6th-order advective flux at south face of grid box - u-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_v              !< 6th-order advective flux at south face of grid box - v-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_w              !< 6th-order advective flux at south face of grid box - w-component
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f1_mg                 !< Siggi
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f2_mg                 !< Siggi
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f3_mg                 !< Siggi
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  mean_inflow_profiles  !< used for turbulent inflow (non-cyclic boundary conditions)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount  !< precipitation amount due to gravitational settling (bulk microphysics)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate    !< precipitation rate (bulk microphysics)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ptnudge               !< vertical profile of pot. temperature interpolated to vertical grid (nudging)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_slope_ref          !< potential temperature in rotated coordinate system 
+                                                                    !< (in case of sloped surface) 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qnudge                !< vertical profile of specific humidity interpolated to vertical grid (nudging) 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tnudge                !< vertical profile of nudging time scale interpolated to vertical grid (nudging)  
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_lpt            !< temperature tendency due to large scale advection (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_q              !< specific humidity tendency due to large scale advection (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_lpt            !< temperature tendency due to subsidence/ascent (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_q              !< specific humidity tendency due to subsidence/ascent (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_a            !< Siggi 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_o            !< Siggi
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug_vert               !< vertical profile of geostrophic wind component in x-direction interpolated to vertical grid (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  unudge                !< vertical profile of wind component in x-direction interpolated to vertical grid (nudging) 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vnudge                !< vertical profile of wind component in y-direction interpolated to vertical grid (nudging) 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg_vert               !< vertical profile of geostrophic wind component in y-direction interpolated to vertical grid (large scale forcing)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wnudge                !< vertical profile of subsidence/ascent velocity interpolated to vertical grid (nudging) ???
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wsubs_vert            !< vertical profile of wind component in z-direction interpolated to vertical grid (nudging) ???
     
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  d          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dx      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dy      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dz      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_e   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_nr  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_pt  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_q   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qr  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_s   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_sa  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_u   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_v   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_w   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_e   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_nr  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_pt  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_q   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qr  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_s   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_sa  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_u   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_v   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_w   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  kh         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  km         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  l_wall     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  prr        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  p_loc      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tend       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tric       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_l      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_n      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_r      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_s      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_l      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_n      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_r      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_s      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_l      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_n      !<  
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_r      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_s      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  d          !< divergence
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dx      !< gradient of sgs tke in x-direction (lpm)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dy      !< gradient of sgs tke in y-direction (lpm)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dz      !< gradient of sgs tke in z-direction (lpm)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss       !< TKE dissipation rate
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_e   !< artificial numerical dissipation flux at left face of grid box - subgrid-scale TKE
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_nr  !< artificial numerical dissipation flux at left face of grid box - raindrop-number concentration
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_pt  !< artificial numerical dissipation flux at left face of grid box - potential temperature
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_q   !< artificial numerical dissipation flux at left face of grid box - mixing ratio
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qr  !< artificial numerical dissipation flux at left face of grid box - rainwater
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_s   !< artificial numerical dissipation flux at left face of grid box - passive scalar
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_sa  !< artificial numerical dissipation flux at left face of grid box - salinity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_u   !< artificial numerical dissipation flux at left face of grid box - u-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_v   !< artificial numerical dissipation flux at left face of grid box - v-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_w   !< artificial numerical dissipation flux at left face of grid box - w-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_e   !< 6th-order advective flux at south face of grid box - subgrid-scale TKE
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_nr  !< 6th-order advective flux at south face of grid box - raindrop-number concentration
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_pt  !< 6th-order advective flux at south face of grid box - potential temperature
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_q   !< 6th-order advective flux at south face of grid box - mixing ratio
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qr  !< 6th-order advective flux at south face of grid box - rainwater
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_s   !< 6th-order advective flux at south face of grid box - passive scalar
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_sa  !< 6th-order advective flux at south face of grid box - salinity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_u   !< 6th-order advective flux at south face of grid box - u-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_v   !< 6th-order advective flux at south face of grid box - v-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_w   !< 6th-order advective flux at south face of grid box - w-component
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  kh         !< eddy diffusivity for heat 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  km         !< eddy diffusivity for momentum
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  l_wall     !< near-wall mixing length
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  prr        !< rain rate
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  p_loc      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tend       !< tendency field (time integration)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tric       !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_l      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_n      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_r      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_s      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_l      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_n      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_r      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_s      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_l      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_n      !< Siggi 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_r      !< Siggi
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_s      !< Siggi
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_p        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_p       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt         !<
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_p       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_p        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_c       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_p       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_ocean  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_p        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa         !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_p       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  te_m       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tnr_m      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tpt_m      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tq_m       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tqr_m      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ts_m       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tsa_m      !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tu_m       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tv_m       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tw_m       !<  
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_p        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_p        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt        !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w          !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e          !< subgrid-scale turbulence kinetic energy (sgs tke)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_p        !< prognostic value of sgs tke
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr         !< rain drop number density
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_p       !< prognostic value of rain drop number density
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p          !< perturbation pressure
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho       !< potential density
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt         !< potential temperature
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_p       !< prognostic value of potential temperature
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q          !< specific humidity
+                                                                   !< (or total water content with active cloud physics)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_p        !< prognostic value of specific humidity 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc         !< cloud water content
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql         !< liquid water content
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_c       !< change in liquid water content due to 
+                                                                   !< condensation/evaporation during last time step
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v       !< volume of liquid water
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp      !< liquid water weighting factor
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr         !< rain water content
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_p       !< prognostic value of rain water content 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_ocean  !< density of ocean
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s          !< passive scalar
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_p        !< prognostic value of passive scalar
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa         !< ocean salinity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_p       !< prognostic value of ocean salinity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  te_m       !< weighted tendency of e for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tnr_m      !< weighted tendency of nr for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tpt_m      !< weighted tendency of pt for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tq_m       !< weighted tendency of q for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tqr_m      !< weighted tendency of qr for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ts_m       !< weighted tendency of s for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tsa_m      !< weighted tendency of sa for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tu_m       !< weighted tendency of u for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tv_m       !< weighted tendency of v for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tw_m       !< weighted tendency of w for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u          !< horizontal velocity component u (x-direction)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_p        !< prognostic value of u
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v          !< horizontal velocity component v (y-direction)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_p        !< prognostic value of v
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt        !< virtual potential temperature
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w          !< vertical velocity component w (z-direction)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_p        !< prognostic value of w
 #else
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_3     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho_1  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_2    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_3    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_2    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_3    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_3     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_2    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_2    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_3    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_1   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_3     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_1    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_2    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_3    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_3     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_3     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt_1   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_1     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_2     !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_3     !< 
-
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  e          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  e_p        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr_p       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  prho       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt_p       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  q          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  q_p        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  qc         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql_c       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr_p       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  rho_ocean  !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  s          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  s_p        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa         !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa_p       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  te_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tnr_m      !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tpt_m      !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tq_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tqr_m      !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  ts_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tsa_m      !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tu_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tv_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tw_m       !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  u          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  u_p        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  v          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  v_p        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  vpt        !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  w          !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  w_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_3     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p       !< pointer: perturbation pressure
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho_1  !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_2    !< pointer for swapping of timelevels for respective quantity 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_3     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v    !< pointer: volume of liquid water
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp   !< pointer: liquid water weighting factor
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_1   !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_3     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_3     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_3     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt_1   !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_1     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_2     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_3     !< pointer for swapping of timelevels for respective quantity
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  e          !< pointer: subgrid-scale turbulence kinetic energy (sgs tke)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  e_p        !< pointer: prognostic value of sgs tke
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr         !< pointer: rain drop number density
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr_p       !< pointer: prognostic value of rain drop number density
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  prho       !< pointer: potential density
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt         !< pointer: potential temperature
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt_p       !< pointer: prognostic value of potential temperature
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  q          !< pointer: specific humidity
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  q_p        !< pointer: prognostic value of specific humidity
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qc         !< pointer: cloud water content
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql         !< pointer: liquid water content
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql_c       !< pointer: change in liquid water content due to 
+                                                       !< condensation/evaporation during last time step
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr         !< pointer: rain water content
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr_p       !< pointer: prognostic value of rain water content
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rho_ocean  !< pointer: density of ocean
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  s          !< pointer: passive scalar
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  s_p        !< pointer: prognostic value of passive scalar
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa         !< pointer: ocean salinity
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa_p       !< pointer: prognostic value of ocean salinity
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  te_m       !< pointer: weighted tendency of e for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tnr_m      !< pointer: weighted tendency of nr for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tpt_m      !< pointer: weighted tendency of pt for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tq_m       !< pointer: weighted tendency of q for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tqr_m      !< pointer: weighted tendency of qr for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ts_m       !< pointer: weighted tendency of s for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tsa_m      !< pointer: weighted tendency of sa for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tu_m       !< pointer: weighted tendency of u for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tv_m       !< pointer: weighted tendency of v for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tw_m       !< pointer: weighted tendency of w for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  u          !< pointer: horizontal velocity component u (x-direction)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  u_p        !< pointer: prognostic value of u
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  v          !< pointer: horizontal velocity component v (y-direction)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  v_p        !< pointer: prognostic value of v
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  vpt        !< pointer: virtual potential temperature
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  w          !< pointer: vertical velocity component w (z-direction)
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  w_p        !< pointer: prognostic value of w
 #endif
 
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  tri      !< 
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  tri      !< Siggi 
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  rho_air      !< air density profile on the uv grid
